<?php
error_reporting(E_ALL & ~E_DEPRECATED);
/** 
 * GentleSource Temporary E-mail - email.class.inc.php
 * 
 * (C) Ralf Stadtaus http://www.gentlesource.com/
 */
require_once 'database.class.inc.php';
/**
 * Manage e-mails
 * 
 */
class t12l_email
{
    /**
     * Number of characters in excerpt
     */
    var $excerpt_length = 200;
    var $delete_emails = true;
    var $maxlength = 20;
    var $runs = 10;
    var $runtime = 300;
    /**
     * Lifetime of an email address in seconds
     */
    var $lifetime = 900;
    /**
     * Number of e-mails to be downloaded during one connection to the mailbox
     */
    var $download_email_num = 200;
    /**
     * Number of connections to the mailbox during one download attempt
     */
    var $download_connection_num = 3;
    // -----------------------------------------------------------------------------
    /**
     * Constructor
     * 
     */
    function t12l_email()
    {
        global $t12l;
        $this->lifetime = t12l_time::convert_to_seconds($t12l['lifetime'], $t12l['lifetime_unit']);
    }
    // -----------------------------------------------------------------------------
    /**
     * Get e-mail address
     * 
     * @access public
     */
    function get_address($set = false)
    {
        // Dispose of old e-mail                
        if (t12l_session::get('address_timestamp') < (t12l_time::current_timestamp() - $this->lifetime)) {
            if ($this->destroy_address()) {
                if ($address = $this->new_address($set)) {
                    $address['time_left'] = $this->lifetime;
                    return $address;
                } else {
                    return false;
                }
            }
        }
        // Get address from existing session
        if ($address = t12l_session::get()) {
            $address['time_left'] = $this->lifetime - (t12l_time::current_timestamp() - $address['address_timestamp']);
            return $address;
        }
        // Create new e-mail
        if ($address = $this->new_address($set)) {
            $address['time_left'] = $this->lifetime;
            return $address;
        } else {
            return false;
        }
    }
    // -----------------------------------------------------------------------------
    /**
     * Reset time
     * 
     * @access public
     */
    function reset_time()
    {
        // Create new address
        $address_email     = t12l_session::get('address_email');
        $address_id        = md5($address_email);
        $address_timestamp = t12l_time::current_timestamp();
        t12l_session::add(array(
            'address_timestamp' => $address_timestamp
        ));
        // Update timestamp in e-mail table
        $data       = array(
            'mail_timestamp' => $address_timestamp
        );
        $where      = " mail_address_id = ? ";
        $where_data = array(
            $address_id
        );
        if ($res = t12l_database::update('mail', $data, $where, $where_data)) {
            // Update timestamp in address table
            $data       = array(
                'address_timestamp' => $address_timestamp
            );
            $where      = " address_id = ? AND address_session_id = ?";
            $where_data = array(
                $address_id,
                session_id()
            );
            if ($res = t12l_database::update('address', $data, $where, $where_data)) {
                return true;
            }
        }
    }
    // -----------------------------------------------------------------------------
    /**
     * Create new address
     * 
     * @access public
     */
    function new_address($set = false)
    {
        global $t12l;
        if ($set == true and isset($t12l['_post']['setemailaddress'])) {
            $address_email = $t12l['_post']['setemailaddress'] . '@' . $t12l['email_address_host_name'];
        } else {
            // Create new address
            $address_email = $this->create_address(8);
        }
        $address_id        = md5($address_email);
        $address_timestamp = t12l_time::current_timestamp();
        // Create new entry        
        $data              = array(
            'address_id' => $address_id,
            'address_email' => $address_email,
            'address_timestamp' => $address_timestamp,
            'address_session_id' => session_id()
        );
        // Write address to database
        if ($res = t12l_database::insert('address', $data)) {
            // Write address to session
            $session = array(
                'address_id' => $address_id,
                'address_email' => $address_email,
                'address_timestamp' => $address_timestamp
            );
            t12l_session::add($session);
            // Write address statistics
            t12l_setting::increase('created_addresses');
            return $data;
        }
    }
    // -----------------------------------------------------------------------------
    /**
     * Create e-mail
     * 
     */
    function create_address($length, $run = 1)
    {
        global $t12l;
        require_once 'Text/Password.php';
        $email_address = Text_Password::create($length) . '@' . $t12l['email_address_host_name'];
        $address_id    = md5($email_address);
        $sql           = "SELECT  address_id FROM " . T12L_ADDRESS_TABLE . " 
                WHERE   address_id = ? ";
        if (!$res = t12l_database::query($sql, array(
            $address_id
        ))) {
            return $email_address;
        }
        if ($res->numRows() > 0) {
            if ($run >= $this->runs) {
                $run = 0;
                $length++;
                if ($length >= $this->maxlength) {
                    t12l_system_debug::add_message('Create Address', 'Too Much Runs', 'error');
                    return false;
                }
            }
            $email_address = $this->create_address($length, ++$run);
        }
        return $email_address;
    }
    //------------------------------------------------------------------------------
    /**
     * Dispose of e-mail
     * 
     */
    function destroy_address()
    {
        $session = array(
            'address_id' => '',
            'address_email' => '',
            'address_timestamp' => ''
        );
        t12l_session::add($session);
        return true;
    }
    //------------------------------------------------------------------------------
    /**
     * Trigger download of e-mails
     * 
     */
    function trigger_mail_download()
    {
        global $t12l;
        @ini_set('max_execution_time', $this->runtime);
        if (!function_exists('imap_open') or $t12l['alternative_mail_download'] == true) {
            require_once 'mailbox.class.inc.php';
        } else {
            require_once 'mailboximap.class.inc.php';
        }
        for ($i = 1; $i <= $this->download_connection_num; $i++) {
            $downloaded_emails = $this->mail_download();
            if ($downloaded_emails == false or $downloaded_emails <= 0) {
                t12l_system_debug::add_message('Trigger Mail Download', 'Number of connections: ' . $i, 'debug');
                return false;
            }
        }
        t12l_system_debug::add_message('Trigger Mail Download', 'Some mails remaining in mailbox', 'debug');
    }
    //------------------------------------------------------------------------------
    /**
     * Download e-mails and write content to database
     * 
     */
    function mail_download()
    {
        global $t12l;
        if (!function_exists('imap_open') or $t12l['alternative_mail_download'] == true) {
            $mail = new t12l_mailbox($this->delete_emails);
        } else {
            $mail = new t12l_mailboximap();
        }
        // Connect to mailbox
        $mailbox_path = 'pop3';
        $mailbox_port = $t12l['mailbox_port'];
        if ($t12l['mailbox_connect_ssl'] == 'Y' and $t12l['alternative_mail_download'] != true) {
            $mailbox_path = 'pop3/ssl';
            $mailbox_port = $t12l['mailbox_port_ssl'];
        }
        $mailbox = array(
            'hostname' => $t12l['mailbox_hostname'],
            'path' => $mailbox_path,
            'port' => $mailbox_port,
            'user' => $t12l['mailbox_username'],
            'password' => $t12l['mailbox_password']
        );
        if (!$mail->open($mailbox)) {
            return false;
        }
        // Number of messages in mailbox
        $number = 0;
        $mail->number($number);
        if ($number <= 0) {
            $mail->close();
            return false;
        }
        t12l_system_debug::add_message('Mailbox Status', $number . ' mail(s) in mailbox.', 'debug');
        $email_number = $this->download_email_num;
        if ($number < $this->download_email_num) {
            $email_number = $number;
        }
        // Check To: headers
        for ($i = 1; $i <= $email_number; $i++) {
            $message = $mail->fetch_message($i);
            $mail->mime_decode($i);
            if (!$to = $mail->get_header($i, 'to')) {
                // Delete e-mail
                $mail->delete_message($i);
                continue;
            }
            $to  = explode(',', $to);
            $num = sizeof($to);
            for ($t = 0; $t < $num; $t++) {
                $mail_address = $to[$t];
                if (strpos($mail_address, '<') !== false) {
                    $mail_address = substr($mail_address, strpos($mail_address, '<') + 1);
                }
                if (strpos($mail_address, '>') !== false) {
                    $mail_address = substr($mail_address, 0, strpos($mail_address, '>'));
                }
                $mail_address = trim($mail_address);
                $mail_host    = substr($mail_address, strpos($mail_address, '@') + 1);
                if ($mail_host != $t12l['email_address_host_name']) {
                    // Delete e-mail 
                    $mail->delete_message($i);
                    continue;
                }
                // Count number of received e-mails
                t12l_setting::increase('received_emails');
                // Check address in database
                $address           = $mail_address;
                $address_id        = md5($address);
                $address_timestamp = t12l_time::current_timestamp() - $this->lifetime;
                $sql               = "SELECT  address_id 
                        FROM    " . T12L_ADDRESS_TABLE . " 
                        WHERE   address_id = ? 
                        AND     address_timestamp > ?";
                if (!$res = t12l_database::query($sql, array(
                    $address_id,
                    $address_timestamp
                ))) {
                    return false;
                }
                if ($res->numRows() > 0) {
                    t12l_system_debug::add_message('Mail Status', 'Mail is valid: ' . $address, 'debug');
                    $subject = $mail->get_header($i, 'subject');
                    $body    = $mail->get_body($i);
                    $from    = $mail->get_header($i, 'from');
                    if ($this->insert_mail($address, $from, $subject, $body)) {
                        // Delete e-mail
                        $mail->delete_message($i);
                    }
                } else {
                    // Delete e-mail
                    $mail->delete_message($i);
                    t12l_system_debug::add_message('Mail Status', 'Mail is NOT valid: ' . $address, 'debug');
                    // Count number of expired e-mails
                    t12l_setting::increase('expired_emails');
                }
            }
        }
        if ($this->delete_emails == true) {
            $mail->perform_delete();
        }
        $mail->close();
        // Return number of mails in mailbox
        return $number;
    }
    //------------------------------------------------------------------------------
    /**
     * Write mail data to database
     * 
     */
    function insert_mail($address, $from, $subject, $body)
    {
        // Write into comment table
        if (!$mail_id = t12l_database::next_id('mail')) {
            return false;
        }
        $mail_data = array(
            'mail_id' => $mail_id,
            'mail_address_id' => md5($address),
            'mail_from' => $from,
            'mail_subject' => $subject,
            'mail_excerpt' => substr($body, 0, $this->excerpt_length),
            'mail_body' => $body,
            'mail_timestamp' => t12l_time::current_timestamp()
        );
        if ($res = t12l_database::insert('mail', $mail_data)) {
            return true;
        }
    }
    //------------------------------------------------------------------------------
    /**
     * Get mail details from database
     * 
     * @access public
     */
    function get_mail($mail)
    {
        global $t12l;
        if (!is_numeric($mail)) {
            return false;
        }
        if (!t12l_session::get('address_id')) {
            return false;
        }
        $sql = "SELECT  m.*
                FROM    " . T12L_MAIL_TABLE . " AS m
                WHERE   m.mail_id = ?
                AND     m.mail_address_id = ?";
        t12l_system_debug::add_message('SQL Statement get_mail()', $sql, 'debug');
        if ($db = t12l_database::query($sql, array(
            (int) $mail,
            t12l_session::get('address_id')
        ))) {
            $res = $db->fetchRow();
            if (PEAR::isError($res)) {
                t12l_system_debug::add_message($res->getMessage(), $res->getDebugInfo(), 'error', $res->getBacktrace());
                t12l_system_debug::add_message('SQL Statement', $sql, 'error');
                return false;
            }
            if (sizeof($res) > 0) {
                // Enhance user data
                $frontend_text = $res['mail_body'];
                $frontend_text = preg_replace('/<a href="(.*?)">(.*?)<\\/a>/i', '<a href="$1">$2 -&gt; $1</a>', $frontend_text);
                $frontend_text = preg_replace('/<http(.*?)>/i', 'http$1', $frontend_text);
                $frontend_text = strip_tags($frontend_text);
                if ($t12l['message_body_format'] != 'html') {
                    $frontend_text = nl2br(htmlentities($frontend_text));
                }
                $enhance = array(
                    'frontend_date' => t12l_time::format_date($res['mail_timestamp']),
                    'frontend_time' => t12l_time::format_time($res['mail_timestamp']),
                    'frontend_text' => $frontend_text,
                    'frontend_subject' => htmlentities(strip_tags($res['mail_subject'])),
                    'frontend_from' => htmlentities($res['mail_from'])
                );
                $final   = array_merge($res, $enhance);
                t12l_module::call_module('frontend_content', $final, $t12l['module_additional']);
                return $final;
            } else {
                $t12l['message'][] = $t12l['text']['txt_mail_not_found'];
                return false;
            }
        }
    }
    // -----------------------------------------------------------------------------
    /**
     * Send reply e-mail
     * 
     */
    function send_reply($mail_id)
    {
        global $t12l;
        if (!$mail_data = $this->get_mail($mail_id)) {
            return false;
        }
        $mail_data['comment']           = $t12l['_post']['text'];
        $mail_data['email']             = '';
        $mail_data['homepage']          = '';
        $mail_data['comment_author_ip'] = getenv('REMOTE_ADDR');
        $mail_data['name']              = t12l_session::get('address_email');
        $page_data                      = array(
            'page_allow_comment' => ''
        );
        t12l_module::call_module('frontend_save_content', $mail_data, $page_data);
        // Reply message blocked
        if ($page_data['page_allow_comment'] == 'N') {
            return false;
        }
        $search                       = array(
            "\r",
            "\n",
            "%0A",
            "%0D"
        );
        // Prepare to
        $reply_to                     = str_replace($search, '', $mail_data['mail_from']);
        // Prepare subject
        $reply_subject                = str_replace($search, '', $mail_data['mail_subject']);
        $reply_subject                = 'RE: ' . $reply_subject;
        // Prepare body
        $reply_body                   = htmlspecialchars(strip_tags($t12l['_post']['text']));
        $detail_template              = 'reply.tpl.txt';
        $t12l['alternative_template'] = 'mail';
        // Start output handling
        $out                          = new t12l_output($detail_template);
        $out->assign('reply_body', $reply_body);
        $reply_coutput = $out->finish_mail();
        // Send mail off
        include 'mail.class.inc.php';
        if (t12l_mail::send($reply_to, $reply_subject, $reply_coutput, t12l_session::get('address_email'))) {
            // Count number of sent e-mails
            t12l_setting::increase('sent_emails');
            return true;
        }
    }
    //------------------------------------------------------------------------------
    /**
     * Delete old mails and addresses
     * 
     */
    function delete_expired()
    {
        $timestamp = (t12l_time::current_timestamp() - $this->lifetime);
        // Delete e-mails
        $where     = " mail_timestamp < ? LIMIT 500";
        $data      = array(
            $timestamp
        );
        if (!$res = t12l_database::delete(T12L_MAIL_TABLE, $where, $data)) {
            return false;
        }
        // Delete addresses
        $where = " address_timestamp < ? LIMIT 500";
        $data  = array(
            $timestamp
        );
        if ($res = t12l_database::delete(T12L_ADDRESS_TABLE, $where, $data)) {
            return true;
        }
    }
    //------------------------------------------------------------------------------
} // End of class
?>