<?php
error_reporting(E_ALL & ~E_DEPRECATED);
/** 
 * GentleSource Comment Script
 * 
 * (C) Ralf Stadtaus http://www.gentlesource.com/
 */
// Settings
define('T12L_ROOT', './');
define('T12L_LOGIN_LEVEL', 0);
$t12l_detail_template = 'email.tpl.html';
$frontend_language    = true;
// Include
require T12L_ROOT . 'include/core.inc.php';
require 'email.class.inc.php';
// -----------------------------------------------------------------------------
// Check for module standalone call
if (t12l_gpc_vars('module')) {
    $module_data = array(
        'data' => t12l_gpc_vars('module')
    );
    t12l_module::call_module('standalone', $module_data, $t12l['module_additional']);
    exit;
}
// -----------------------------------------------------------------------------
// Start mail handling
$mail = new t12l_email();
// -----------------------------------------------------------------------------
// Redirect
if (t12l_gpc_vars('getemail')) {
    if ($mail->get_address()) {
        header('Location: ' . $t12l['server_protocol'] . $t12l['server_name'] . $_SERVER['REQUEST_URI']);
        exit;
    } else {
        $t12l['message'][] = $t12l['text']['txt_could_not_create_email'];
    }
}
// -----------------------------------------------------------------------------
// Ditch e-mail address
if (t12l_gpc_vars('ditchemail')) {
    $mail->destroy_address();
    header('Location: ' . $t12l['server_protocol'] . $t12l['server_name'] . $_SERVER['REQUEST_URI']);
}
// -----------------------------------------------------------------------------
$out = new t12l_output($t12l_detail_template);
// -----------------------------------------------------------------------------
// Build e-mail address from input and from defined e-mail host name
if (isset($t12l['_post']['setemail'])) {
    $_POST['setemailaddressintern'] = $_POST['setemailaddress'] . '@' . $t12l['email_address_host_name'];
}
// Handle and validate form
require_once 'HTML/QuickForm.php';
// Start form handler
$form = new HTML_QuickForm('account', 'POST');
// Get form configuration
require 'email_form.inc.php';
// Validate form
$message = array();
if (isset($t12l['_post']['setemail']) and $form->validate()) {
    $mail->get_address(true);
    header('Location: ' . $t12l['server_protocol'] . $t12l['server_name'] . $_SERVER['REQUEST_URI']);
    exit;
}
require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';
$renderer = new HTML_QuickForm_Renderer_ArraySmarty($out->get_object, true);
$form->accept($renderer);
// Assign array with form data
$out->assign('form', $renderer->toArray());
// -----------------------------------------------------------------------------
$show_address = false;
if (t12l_session::get('address_id')) {
    $show_address = true;
}
$out->assign('show_address', $show_address);
// -----------------------------------------------------------------------------
if (t12l_session::get('address_id')) {
    $address_data                 = $mail->get_address();
    $address_data['minutes_left'] = round($address_data['time_left'] / 60);
    $out->assign($address_data);
}
// -----------------------------------------------------------------------------
// Get mail content
$show_mail_details = false;
if (t12l_session::get('address_id') and $mail_id = t12l_gpc_vars('m')) {
    if ($mail_details = $mail->get_mail($mail_id)) {
        $out->assign($mail_details);
        $show_mail_details = true;
        $show_mail_list    = false;
    }
}
// -----------------------------------------------------------------------------
// Get mail list
$show_mail_list = false;
if ($show_mail_details == false and $address = t12l_session::get('address_id')) {
    include 'emaillist.class.inc.php';
    $mail_list_setup = array(
        'direction' => $t12l['frontend_order'],
        'limit' => 0
    );
    $mail_list       = new t12l_email_list(false, $mail_list_setup);
    if ($mail_data = $mail_list->get_list($address)) {
        $out->assign('mail_list', $mail_data);
        $show_mail_list = true;
    } else {
        $t12l['message'][] = $t12l['text']['txt_no_emails'];
    }
    $mail_list_values = $mail_list->values();
    $out->assign($mail_list_values);
}
// -----------------------------------------------------------------------------
// Display reply form and send e-mail
$show_reply_form = false;
if (t12l_session::get('address_id') and t12l_gpc_vars('d') == 'r' and $mail_id = t12l_gpc_vars('m') and $show_mail_details == true) {
    $show_reply_form = true;
    require_once 'HTML/QuickForm.php';
    $form = new HTML_QuickForm('reply', 'POST');
    $form->addElement('textarea', 'text', $t12l['text']['txt_reply'], array(
        'rows' => 8,
        'cols' => 30
    ));
    $form->addElement('submit', 'save', $t12l['text']['txt_submit']);
    $form->addElement('hidden', 'm');
    $form->addElement('hidden', 'd');
    $form->addRule('text', $t12l['text']['txt_enter_reply_text'], 'required');
    $defaults = array(
        'd' => 'r',
        'm' => $mail_id
    );
    $form->setConstants($defaults);
    if ($form->validate()) {
        if ($mail->send_reply($mail_id)) {
            $t12l['message'][] = $t12l['text']['txt_reply_has_been_sent'];
            $show_reply_form   = false;
        } else {
            $t12l['message'][] = $t12l['text']['txt_reply_has_not_been_sent'];
        }
    }
    require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';
    $renderer = new HTML_QuickForm_Renderer_ArraySmarty($out->get_object, true);
    $form->accept($renderer);
    $out->assign('reply', $renderer->toArray());
}
// -----------------------------------------------------------------------------
// Delete expired e-mails and addresses
$mail->delete_expired();
// -----------------------------------------------------------------------------
// Reset time
if (t12l_gpc_vars('resettime')) {
    $mail->reset_time();
    header('Location: ' . $t12l['server_protocol'] . $t12l['server_name'] . $_SERVER['REQUEST_URI']);
}
// -----------------------------------------------------------------------------
// Output
$out->assign('page_data', array(
    'page_title' => $t12l['text']['txt_disposable_email_address']
));
$out->assign('show_mail_details', $show_mail_details);
$out->assign('show_mail_list', $show_mail_list);
$out->assign('show_reply_form', $show_reply_form);
$out->assign('message', $message);
$out->finish();
?>